import { combineForms } from 'react-redux-form'
import { routerReducer } from 'react-router-redux'

import movieStore from './movies'
import showsStore from './shows'
import showStore from './show'
import userStore from './users'
import alerts from './alerts'
import torrentStore from './torrents'

// Use combine form form react-redux-form, it's a thin wrapper arround the
// default combinedReducers provided with React. It allows the forms to be
// linked directly to the store.
const rootReducer = combineForms({
  routing: routerReducer,
  movieStore,
  showsStore,
  showStore,
  userStore,
  alerts,
  torrentStore,
})

export default rootReducer;
